!unit   length:Angstrom energy:eV Dipole:Debye
program pes_dms
implicit none
integer,parameter::num=100000
character(len=2)::atom(9)
real(kind=8)::x(3,9,num),y12(3,6,num),y13(3,6,num),pesSO2,pes2b_SO2_H2O,pes3b_SO2_2H2O,dmsSO2(3),dms2b_SO2_H2O(3),dms3b_SO2_2H2O(3),f,f2b,f3b, d1(3) , d2(3)
integer::n,i,natom

n=0
open(1,file="min-01.xyz",status='old')
do while(.true.)
  read(1,*,end=99) natom
  do i=1,natom
    read(1,*) atom(i),x(:,i,n+1)
  enddo
  n=n+1
  y12(:,1:4,n)=x(:,1:4,n)
  y12(:,5:6,n)=x(:,6:7,n)
  y13(:,1:3,n)=x(:,1:3,n)
  y13(:,4,n)=x(:,5,n)
  y13(:,5:6,n)=x(:,8:9,n)
enddo

99 close(1)

do i=1,n
   
   pesSO2=f(x(:,1:3,i))  !SO2 1-body energy
   pes2b_SO2_H2O=f2b(y12(:,:,i))+f2b(y13(:,:,i))   !SO2-H2O 2-body interaction energy
   pes3b_SO2_2H2O=f3b(x(:,:,i)) !SO2-H2O-H2O 3-body interaction energy
  

   call dms_SO2(x(:,1:3,i),dmsSO2) ! SO2 dipole moment
   call dms2b_SO3H2(y12(:,:,i),d1) !SO2-H2O 2-body dipole moment
   call dms2b_SO3H2(y13(:,:,i),d2) !SO2-H2O 2-body dipole moment  
   dms2b_SO2_H2O =  d1 + d2
   call dms3b_SO4H4(x(:,:,i),dms3b_SO2_2H2O) !SO2-H2O-H2O 3-body dipole moment

   write(100,* ) "SO2 1-body energy (in eV):"
   write(100,"((es23.16,1x))") pesSO2 
   write(100,* ) "SO2-H2O 2-body interaction energy (in eV):"
   write(100,"((es23.16,1x))") pes2b_SO2_H2O
   write(100,* ) "SO2-H2O-H2O 3-body interaction energy (in eV):"
   write(100,"((es23.16,1x))") pes3b_SO2_2H2O
   write(100,* ) "SO2 dipole moment (in Debye):"
   write(100,"(3(es23.16,1x))") dmsSO2 
   write(100,* ) "SO2-H2O 2-body dipole moment (in Debye):" 
   write(100,"(3(es23.16,1x))") dms2b_SO2_H2O 
   write(100,* ) "SO2-H2O-H2O 3-body dipole moment (in Debye):"
   write(100,"(3(es23.16,1x))") dms3b_SO2_2H2O
 
end do



end program pes_dms



