subroutine rmat(cost,phi,xi,r)
!---------------------------------------------------------
! R_Z(xi) R_Y(theta) R_Z(phi)
! .-            -. .-            -. .-            -.
! | cosx -sinx 0 | |  cost 0 sint | | cosp -sinp 0 |
! | sinx  cosx 0 | |  0    1    0 | | sinp  cosp 0 |
! | 0     0    1 | | -sint 0 cost | | 0     0    1 |
!  --          --   --          --   --          --
!---------------------------------------------------------
implicit none
real(kind=8), intent(out) :: r(3,3)
real(kind=8), intent(in) :: cost,phi,xi
real(kind=8) :: sint,sinp,cosp,sinx,cosx
real(kind=8),parameter :: pi=3.1415926535897932d0
sint=dsqrt(1.d0-cost**2)
sinp=dsin(phi)
sinx=dsin(xi)
cosp=dcos(phi)
cosx=dcos(xi)

r(1,1)= cost*cosp*cosx-sinp*sinx
r(1,2)=-cost*sinp*cosx-cosp*sinx
r(1,3)= sint*cosx
r(2,1)= cost*cosp*sinx+sinp*cosx
r(2,2)=-cost*sinp*sinx+cosp*cosx
r(2,3)= sint*sinx
r(3,1)=-sint*cosp
r(3,2)= sint*sinp
r(3,3)= cost
end subroutine rmat
!---------------------------------------------------------------
subroutine nizhen(aa,b,n)
integer :: n,i,j,k
real*8 :: aa(n,n),b(n,n),a(n,n)
a=aa
do i=1,n
b(i,i)=1
enddo
do i=1,n
b(i,:)=b(i,:)/a(i,i)
a(i,i:n)=a(i,i:n)/a(i,i)
do j=i+1,n
do k=1,n
b(j,k)=b(j,k)-b(i,k)*a(j,i)
enddo
a(j,i:n)=a(j,i:n)-a(i,i:n)*a(j,i)
enddo
enddo
do i=n,1,-1
do j=i-1,1,-1
do k=1,n
b(j,k)=b(j,k)-b(i,k)*a(j,i)
enddo
enddo
enddo
end subroutine nizhen
